#include <sdktools>

new Handle:ghFlagModelPath;
new String:gsFlagModelPath[256];
new Handle:ghFlagSoundPath;
new String:gsFlagSoundPath[256];
new Handle:ghFlagSoundInterval;
new Float:gfFlagSoundInterval;
new Handle:ghFlagPlantSoundPath;
new String:gsFlagPlantSoundPath[256];
new Handle:ghDownloader;
new String:gsDownloaderPath[256];
new Handle:ghC4DefuseFrags;
new giC4DefuseFrags;
new Handle:ghC4Explodefrags;
new giC4Explodefrags;
new iFlag;
new giC4Index;
new Handle:ghSoundRepeat;
new Float:gfFlagPos[3];

public OnPluginStart()
{
	HookEvent("bomb_planted",Event_BombPlanted);
	HookEvent("bomb_exploded",Event_BombExploded);
	HookEvent("bomb_defused",Event_BombDefused);
	HookEvent("round_end",Event_RoundEnd);
	HookEvent("round_start",Event_RoundStart);
	ghFlagModelPath=CreateConVar("c4_model","models/flag_isis_russia_anim.mdl","Путь до модели флага");
	ghFlagSoundPath=CreateConVar("c4_sound","kms_jd/sound_flag_wind.wav","Путь до звука флага");
	ghFlagSoundInterval=CreateConVar("c4_soundinterval","7.0","Интервал звука флага");
	ghFlagPlantSoundPath=CreateConVar("c4_plantsound","quake/c4powa.mp3","Путь до звука установки флага");
	ghDownloader=CreateConVar("sm_downloader","addons/sourcemod/configs/downloader.ini","Путь к файлу с загрузками");
	ghC4DefuseFrags=CreateConVar("c4_defusefrags","3","Сколько игрок получает фрагов за разминирование бомбы");
	ghC4Explodefrags=CreateConVar("c4_explodefrags","3","Сколько игрок получает фрагов за успешный взрыв бомбы");
	AutoExecConfig(true,"c4flags");
}

public OnConfigsExecuted()
{
	GetConVarString(ghFlagModelPath,gsFlagModelPath,sizeof(gsFlagModelPath)-1);
	GetConVarString(ghFlagSoundPath,gsFlagSoundPath,sizeof(gsFlagSoundPath)-1);
	gfFlagSoundInterval=GetConVarFloat(ghFlagSoundInterval);
	GetConVarString(ghFlagPlantSoundPath,gsFlagPlantSoundPath,sizeof(gsFlagPlantSoundPath)-1);
	GetConVarString(ghDownloader,gsDownloaderPath,sizeof(gsDownloaderPath)-1);
	giC4DefuseFrags=GetConVarInt(ghC4DefuseFrags);
	giC4Explodefrags=GetConVarInt(ghC4Explodefrags);
}

public OnMapStart()
{
	ghDownloader=OpenFile(gsDownloaderPath,"r"); 
	if(ghDownloader==INVALID_HANDLE) 
	{ 
		SetFailState("Не удалось открыть %s",gsDownloaderPath); 
		return;
	} 
	while(!IsEndOfFile(ghDownloader)&&ReadFileLine(ghDownloader,gsDownloaderPath,sizeof(gsDownloaderPath)-1)) 
	{ 
		TrimString(gsDownloaderPath); 
		if(IsCharAlpha(gsDownloaderPath[0]))
		{
			AddFileToDownloadsTable(gsDownloaderPath);
			if(StrContains(gsDownloaderPath,".mdl",false)!=-1)
			{
				PrecacheModel(gsDownloaderPath,true);
			}
			else 
			{
				if(StrContains(gsDownloaderPath,".wav",false)!=-1||StrContains(gsDownloaderPath,".mp3",false)!=-1)
				{
					ReplaceString(gsDownloaderPath,sizeof(gsDownloaderPath)-1,"sound/",""); 
					PrecacheSound(gsDownloaderPath,true);
				}
			}
		}
	}
}

public Event_BombPlanted(Handle:hEvent,String:sName[],bool:bDontBroadcast)
{
	new iClient=GetClientOfUserId(GetEventInt(hEvent,"userid"));
	giC4Index=FindEntityByClassname(MaxClients+1,"planted_c4");
	if(giC4Index>0)
	{
		iFlag=CreateEntityByName("prop_dynamic",-1);
		SetEntityModel(iFlag,gsFlagModelPath);
		DispatchKeyValue(iFlag,"DefaultAnim","movie");
		DispatchKeyValue(iFlag,"solid","6");
		DispatchKeyValue(iFlag,"skin","1");
		DispatchSpawn(iFlag);
		decl Float:fC4Pos[3];
		GetEntPropVector(giC4Index,Prop_Send,"m_vecOrigin",fC4Pos);
		gfFlagPos[0]=fC4Pos[0];
		gfFlagPos[1]=(fC4Pos[1]+72);
		gfFlagPos[2]=(fC4Pos[2]+150);
		TeleportEntity(iFlag,gfFlagPos,NULL_VECTOR,NULL_VECTOR);
		EmitAmbientSound(gsFlagSoundPath,gfFlagPos,iFlag, 75, 0, 1.0, 100, 0.0);
		ghSoundRepeat=CreateTimer(gfFlagSoundInterval,Timer_SoundRepeat);
		if(iClient)
		{
			EmitSoundToClient(iClient,gsFlagPlantSoundPath, -2, 0, 140, 0, 1.0, 100);
		}
	}
}

public Event_BombDefused(Handle:hEvent,String:sName[],bool:bDontBroadcast)
{
	new iClient=GetClientOfUserId(GetEventInt(hEvent,"userid"));
	if(iClient)
	{
		SetEntProp(iClient,Prop_Data,"m_iFrags",GetClientFrags(iClient)+giC4DefuseFrags);
	}
	DispatchKeyValue(iFlag,"skin","0");
	Func_CloseTimer();
}

public Event_BombExploded(Handle:hEvent,String:sName[],bool:bDontBroadcast)
{
	new iClient=GetClientOfUserId(GetEventInt(hEvent,"userid"));
	if(iClient)
	{
		SetEntProp(iClient,Prop_Data,"m_iFrags",GetClientFrags(iClient)+giC4Explodefrags);
	}
	Func_CloseTimer();
}

public Event_RoundEnd(Handle:hEvent,String:sName[],bool:bDontBroadcast)
{
	if(giC4Index>0&&IsValidEntity(giC4Index))
	{
		decl String:sClass[16];
		if (GetEntityClassname(giC4Index,sClass,sizeof(sClass)-1)&&strcmp(sClass,"planted_c4",true))
		{
			new iDissolver=CreateEntityByName("env_entity_dissolver",-1);
			if(iDissolver)
			{
				DispatchKeyValue(iDissolver,"target","planted_c4");
				DispatchKeyValue(iDissolver,"magnitude","1");
				DispatchKeyValue(iDissolver,"dissolvetype","0");
				AcceptEntityInput(iDissolver,"Dissolve");
				AcceptEntityInput(iDissolver,"Kill");
			}
		}
		Func_CloseTimer();
	}
}

public Event_RoundStart(Handle:hEvent,String:sName[],bool:bDontBroadcast)
{
	giC4Index=0;
	iFlag=0;
	Func_CloseTimer();
}

public Action: Timer_SoundRepeat(Handle:hTimer)
{
	EmitAmbientSound(gsFlagSoundPath,gfFlagPos,iFlag, 75, 0, 1.0, 100, 0.0);
}

Func_CloseTimer()
{
	if(ghSoundRepeat!=INVALID_HANDLE)
	{
		KillTimer(ghSoundRepeat);
		ghSoundRepeat=INVALID_HANDLE;
	}
	for(new iClient=1;iClient<=MaxClients;iClient++)
	{
		if(IsClientInGame(iClient))
		{
			StopSound(iClient,SNDCHAN_AUTO,gsFlagSoundPath);
		}
	}
}